package com.stormtales.notevault.ui.songeditor;

import android.app.AlertDialog;
import android.app.Dialog;
import android.net.Uri;
import android.os.Bundle;
import android.text.Layout;
import android.widget.Button;
import android.widget.EditText;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import androidx.lifecycle.ViewModelProvider;
import com.stormtales.notevault.R;
import com.stormtales.notevault.data.entities.Song;
import com.stormtales.notevault.ui.home.HomeViewModel;
import org.jetbrains.annotations.NotNull;


public class SongEditorDialog extends DialogFragment {

    Dialog dialog;
    private Uri[] noteSheetFiles;
    private HomeViewModel homeViewModel;

    public SongEditorDialog() {
        // Required empty public constructor
    }


    @NonNull
    @Override
    public @NotNull Dialog onCreateDialog(@Nullable @org.jetbrains.annotations.Nullable Bundle savedInstanceState) {
        LayoutInflater inflater = LayoutInflater.from(getContext());
        View dialogView = inflater.inflate(R.layout.fragment_song_editor_dialog, null);

        dialogView.findViewById(R.id.btnCancel).setOnClickListener(v-> onCancel());
        dialogView.findViewById(R.id.btnSave).setOnClickListener(v -> onSave());

        AlertDialog.Builder builder = new AlertDialog.Builder(getContext());
        builder.setCancelable(false);
        builder.setView(dialogView);

        dialog = builder.create();
        dialog.setCanceledOnTouchOutside(false);
        return dialog;
    }

    private void onCancel() {
        dialog.dismiss();
    }

    private void onSave() {
        String title = ((EditText) dialog.findViewById(R.id.etTitle)).getText().toString();
        String composer = ((EditText) dialog.findViewById(R.id.etComposer)).getText().toString();

        String year_string = ((EditText) dialog.findViewById(R.id.etYear)).getText().toString();
        int releaseYear = year_string.isBlank()? 0 : Integer.parseInt(year_string);
        String genre = ((EditText) dialog.findViewById(R.id.etGenre)).getText().toString();

        Song song = new Song(title, composer, genre, releaseYear);
        homeViewModel.addSong(song);


        dialog.dismiss();

    }

    public void setNoteSheetFiles(Uri[] noteSheetFiles) {
        this.noteSheetFiles = noteSheetFiles;
    }

    public void setHomeViewModel(HomeViewModel homeViewModel) {
        this.homeViewModel = homeViewModel;
    }
}